commit f7785eb3acabc35f470ae49eb2dc7af184c99c46
Author: jklowden <jklowden>
Date:   Sat Dec 20 06:01:47 2008 +0000

    added fakepoll

diff --git a/src/replacements/Makefile.am b/src/replacements/Makefile.am
index 7ff6a92..ab13b33 100644
--- a/src/replacements/Makefile.am
+++ b/src/replacements/Makefile.am
@@ -1,8 +1,15 @@
-# $Id: Makefile.am,v 1.13 2006/06/14 15:30:13 freddy77 Exp $
-AM_CPPFLAGS=			-I$(top_srcdir)/include
+# $Id: Makefile.am,v 1.14 2008/12/20 06:01:47 jklowden Exp $
+AM_CPPFLAGS=			-I$(top_srcdir)/include -I$(top_srcdir)/src/replacements
 noinst_LTLIBRARIES=		libreplacements.la
-libreplacements_la_SOURCES=	iconv.c gettimeofday.c
+libreplacements_la_SOURCES=	iconv.c gettimeofday.c fakepoll.c fakepoll.h
 libreplacements_la_LDFLAGS=
 libreplacements_la_LIBADD=	@LTLIBOBJS@
-EXTRA_DIST=			asprintf.c vasprintf.c atoll.c strtok_r.c \
-	readpassphrase.c basename.c strlcpy.c strlcat.c
+EXTRA_DIST=	asprintf.c \
+		atoll.c \
+		basename.c \
+		readpassphrase.c \
+		strlcat.c \
+		strlcpy.c \
+		strtok_r.c \
+		vasprintf.c 
+
diff --git a/src/replacements/fakepoll.c b/src/replacements/fakepoll.c
new file mode 100644
index 0000000..b49abbd
--- /dev/null
+++ b/src/replacements/fakepoll.c
@@ -0,0 +1,167 @@
+#ifndef HAVE_POLL
+/*
+ * poll(2) implemented with select(2), for systems without poll(2). 
+ * Warning: a call to this poll() takes about 4K of stack space.
+ *
+ * This file and the accompanying fakepoll.h  
+ * are based on fakepoll.h in C++ by 
+ * 
+ * Greg Parker	 gparker-web@sealiesoftware.com     December 2000
+ * This code is in the public domain. 
+ *
+ * Updated May 2002: 
+ * * fix crash when an fd is less than 0
+ * * set errno=EINVAL if an fd is greater or equal to FD_SETSIZE
+ * * don't set POLLIN or POLLOUT in revents if it wasn't requested 
+ *   in events (only happens when an fd is in the poll set twice)
+ *
+ * Converted to C and spruced up by James K. Lowden December 2008. 
+ */
+
+static char software_version[] = "$Id: fakepoll.c,v 1.1 2008/12/20 06:01:47 jklowden Exp $";
+static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
+
+#include "fakepoll.h"
+
+#if HAVE_SYS_TYPES_H
+#include <sys/types.h>
+#endif /* HAVE_SYS_TYPES_H */
+
+#if HAVE_ERRNO_H
+#include <errno.h>
+#endif /* HAVE_ERRNO_H */
+
+#if HAVE_UNISTD_H
+#include <unistd.h>
+#endif /* HAVE_UNISTD_H */
+
+#if TIME_WITH_SYS_TIME
+# if HAVE_SYS_TIME_H
+#  include <sys/time.h>
+# endif
+# include <time.h>
+#else
+# if HAVE_SYS_TIME_H
+#  include <sys/time.h>
+# else
+#  include <time.h>
+# endif
+#endif
+
+#include <string.h>
+#include <assert.h>
+
+int
+fakepoll(struct pollfd fds[], int nfds, int timeout)
+{
+	struct timeval tv, *tvp;
+	fd_set fdsr, fdsw, fdsp;
+	struct pollfd *p;
+	const struct pollfd *endp = fds? fds + nfds : NULL;
+	int selected, polled = 0, maxfd = 0;
+
+	if (fds == NULL) {
+		errno = EFAULT;
+		return -1;
+	}
+
+	FD_ZERO(&fdsr);
+	FD_ZERO(&fdsw);
+	FD_ZERO(&fdsp);
+
+	/* 
+	 * Transcribe flags from the poll set to the fd sets. 
+	 * Also ensure we don't exceed select's capabilities. 
+	 */
+	for (p = fds; p < endp; p++) {
+		/* Negative fd checks nothing and always reports zero */
+		if (p->fd < 0) {
+			continue;
+		} 
+
+		if (p->fd > maxfd)
+			maxfd = p->fd;
+
+		/* POLLERR is never set coming in; poll(2) always reports errors */
+		/* But don't report if we're not listening to anything at all. */
+		if (p->events & POLLIN)
+			FD_SET(p->fd, &fdsr);
+		if (p->events & POLLOUT)
+			FD_SET(p->fd, &fdsw);
+		if (p->events != 0)
+			FD_SET(p->fd, &fdsp);
+	}
+
+	/* 
+	 * If any FD is too big for select(2), we need to return an error. 
+	 * Which one, though, is debatable.  There's no defined errno for 
+	 * this for poll(2) because it's an "impossible" condition; 
+	 * there's no such thing as "too many" FD's to check.  
+	 * select(2) returns EINVAL, and so do we.  
+	 * EFAULT might be better.
+	 */ 
+	if (maxfd > FD_SETSIZE) {
+		assert(FD_SETSIZE > 0);
+		errno = EINVAL;
+		return -1;
+	}
+
+	/*
+	 * poll timeout is in milliseconds. Convert to struct timeval.
+	 *      timeout == -1: wait forever : select timeout of NULL
+	 *      timeout ==  0: return immediately : select timeout of zero
+	 */
+	if (timeout >= 0) {
+		tv.tv_sec = timeout / 1000;
+		tv.tv_usec = (timeout % 1000) * 1000;
+		tvp = &tv;
+	} else {
+		tvp = NULL;
+	}
+
+	/* 
+	 * call select(2) 
+	 */
+	if ((selected = select(maxfd+1, &fdsr, &fdsw, &fdsp, tvp)) < 0) {
+		return -1; /* error */
+	}
+	
+	/* timeout, clear all result bits and return zero. */
+	if (selected == 0) {	
+		for (p = fds; p < endp; p++) {
+			p->revents = 0;
+		}
+		return 0;
+	}
+
+	/*
+	 * Select found something
+	 * Transcribe result from fd sets to poll set.
+	 * Return the number of ready fds.
+	 */
+	for (polled=0, p=fds; p < endp; p++) {
+		p->revents = 0;
+		/* Negative fd always reports zero */
+		if (p->fd < 0) {
+			continue;
+		}
+		
+		if ((p->events & POLLIN) && FD_ISSET(p->fd, &fdsr)) {
+			p->revents |= POLLIN;
+		}
+		if ((p->events & POLLOUT) && FD_ISSET(p->fd, &fdsw)) {
+			p->revents |= POLLOUT;
+		}
+		if ((p->events != 0) && FD_ISSET(p->fd, &fdsp)) {
+			p->revents |= POLLERR;
+		}
+
+		if (p->revents)
+			polled++;
+	}
+	
+	assert(polled == selected);
+
+	return polled;
+}
+#endif /* HAVE_POLL */
diff --git a/src/replacements/fakepoll.h b/src/replacements/fakepoll.h
new file mode 100644
index 0000000..d40518d
--- /dev/null
+++ b/src/replacements/fakepoll.h
@@ -0,0 +1,51 @@
+/* $Id: fakepoll.h,v 1.1 2008/12/20 06:01:47 jklowden Exp $ */
+#if !defined(_FAKE_POLL_H) && !defined(HAVE_POLL)
+#define _FAKE_POLL_H
+
+#if HAVE_CONFIG_H
+#include <config.h>
+#endif 
+
+
+#if HAVE_LIMITS_H
+#include <limits.h>
+#endif 
+
+#if HAVE_SYS_SELECT_H
+#include <sys/select.h>
+#endif 
+
+#if !defined(FD_SETSIZE)
+# if !defined(OPEN_MAX)
+# error cannot establish FD_SETSIZE
+# endif
+#define FD_SETSIZE OPEN_MAX
+#endif
+
+// poll flags
+#define POLLIN  0x0001
+#define POLLOUT 0x0004
+#define POLLERR 0x0008
+
+// synonyms
+#define POLLNORM POLLIN
+#define POLLPRI POLLIN
+#define POLLRDNORM POLLIN
+#define POLLRDBAND POLLIN
+#define POLLWRNORM POLLOUT
+#define POLLWRBAND POLLOUT
+
+// ignored
+#define POLLHUP 0x0010
+#define POLLNVAL 0x0020
+
+typedef struct pollfd {
+    int fd;		/* file descriptor to poll */
+    short events;	/* events of interest on fd */
+    short revents;	/* events that occurred on fd */
+} pollfd_t;
+
+
+int fakepoll(struct pollfd fds[], int nfds, int timeout);
+
+#endif

